TRANSITION_DURATION = 1.2;

var sceneTransitions = {

    "JumpZoomTransition": function (t, s) {
        return new cc.TransitionJumpZoom(t, s);
    },
    "TransitionProgressRadialCCW": function (t, s) {
        return new cc.TransitionProgressRadialCCW(t, s);
    },
    "TransitionProgressRadialCW": function (t, s) {
        return new cc.TransitionProgressRadialCW(t, s);
    },
    "TransitionProgressHorizontal": function (t, s) {
        return new cc.TransitionProgressHorizontal(t, s);
    },
    "TransitionProgressVertical": function (t, s) {
        return new cc.TransitionProgressVertical(t, s);
    },
    "TransitionProgressInOut": function (t, s) {
        return new cc.TransitionProgressInOut(t, s);
    },
    "TransitionProgressOutIn": function (t, s) {
        return new cc.TransitionProgressOutIn(t, s);
    },
    "FadeTransition": function (t, s) {
        return new cc.TransitionFade(t, s);
    },
    "FadeWhiteTransition": function (t, s) {
        return new cc.TransitionFade(t, s, cc.color(255, 255, 255));
    },
    "ShrinkGrowTransition": function (t, s) {
        return new cc.TransitionShrinkGrow(t, s);
    },
    "RotoZoomTransition": function (t, s) {
        return new cc.TransitionRotoZoom(t, s);
    },
    "MoveInLTransition": function (t, s) {
        return new cc.TransitionMoveInL(t, s);
    },
    "MoveInRTransition": function (t, s) {
        return new cc.TransitionMoveInR(t, s);
    },
    "MoveInTTransition": function (t, s) {
        return new cc.TransitionMoveInT(t, s);
    },
    "MoveInBTransition": function (t, s) {
        return new cc.TransitionMoveInB(t, s);
    },
    "SlideInLTransition": function (t, s) {
        return new cc.TransitionSlideInL(t, s);
    },
    "SlideInRTransition": function (t, s) {
        return new cc.TransitionSlideInR(t, s);
    },
    "SlideInTTransition": function (t, s) {
        return new cc.TransitionSlideInT(t, s);
    },
    "SlideInBTransition": function (t, s) {
        return new cc.TransitionSlideInB(t, s);
    },
    "CCTransitionRadialCCW": function (t, s) {
        return new cc.TransitionProgressRadialCCW(t, s);
    },
    "CCTransitionRadialCW": function (t, s) {
        return new cc.TransitionProgressRadialCW(t, s);
    },
    "FlipXLeftOver": function (t, s) {
        return new cc.TransitionFlipX(t, s, cc.TRANSITION_ORIENTATION_LEFT_OVER);
    },
    "FlipXRightOver": function (t, s) {
        return new cc.TransitionFlipX(t, s, cc.TRANSITION_ORIENTATION_RIGHT_OVER);
    },
    "FlipYUpOver": function (t, s) {
        return FlipYUpOver(t, s);
    },
    "FlipYDownOver": function (t, s) {
        return new cc.TransitionFlipY(t, s, cc.TRANSITION_ORIENTATION_DOWN_OVER);
    },
    "FlipAngularLeftOver": function (t, s) {
        return new cc.TransitionFlipAngular(t, s, cc.TRANSITION_ORIENTATION_LEFT_OVER);
    },
    "FlipAngularRightOver": function (t, s) {
        return new cc.TransitionFlipAngular(t, s, cc.TRANSITION_ORIENTATION_RIGHT_OVER);
    },
    "ZoomFlipXLeftOver": function (t, s) {
        return new cc.TransitionZoomFlipX(t, s, cc.TRANSITION_ORIENTATION_LEFT_OVER);
    },
    "ZoomFlipXRightOver": function (t, s) {
        return new cc.TransitionZoomFlipX(t, s, cc.TRANSITION_ORIENTATION_RIGHT_OVER);
    },
    "ZoomFlipYUpOver": function (t, s) {
        return new cc.TransitionZoomFlipY(t, s, cc.TRANSITION_ORIENTATION_UP_OVER);
    },
    "ZoomFlipYDownOver": function (t, s) {
        return new cc.TransitionZoomFlipY(t, s, cc.TRANSITION_ORIENTATION_DOWN_OVER);
    },
    "ZoomFlipAngularLeftOver": function (t, s) {
        return new cc.TransitionZoomFlipAngular(t, s, cc.TRANSITION_ORIENTATION_LEFT_OVER);
    },
    "ZoomFlipAngularRightOver": function (t, s) {
        return new cc.TransitionZoomFlipAngular(t, s, cc.TRANSITION_ORIENTATION_RIGHT_OVER);
    },
    "PageTransitionForward": function (t, s) {
        return new cc.TransitionPageTurn(t, s, false);
    },
    "PageTransitionBackward": function (t, s) {
        return new cc.TransitionPageTurn(t, s, true);
    },
    "FadeTRTransition": function (t, s) {
        return new cc.TransitionFadeTR(t, s);
    },
    "FadeBLTransition": function (t, s) {
        return new cc.TransitionFadeBL(t, s);
    },
    "FadeUpTransition": function (t, s) {
        return new cc.TransitionFadeUp(t, s);
    },
    "FadeDownTransition": function (t, s) {
        return new cc.TransitionFadeDown(t, s);
    },
    "TurnOffTilesTransition": function (t, s) {
        return new cc.TransitionTurnOffTiles(t, s);
    },
    "SplitRowsTransition": function (t, s) {
        return new cc.TransitionSplitRows(t, s);
    },
    "CCTransitionCrossFade": function (t, s) {
        return new cc.TransitionSplitCols(t, s);
    },
    "SplitColsTransition": function (t, s) {
        return new cc.TransitionSplitCols(t, s);
    }
}


var view_size = [
    [480, 320],
    [854, 480],
    [800, 480],
    [960, 540],
    [960, 640],
    [1024, 768],
    [1024, 600],
    [1136, 640],
    [1334, 750],
    [1280, 768],
    [1280, 800],
    [1920, 1080],
    [2048, 1536]
];

function setViewSize(idx) {
    idx = idx % view_size.length;
    var size = view_size[idx];
    if (idx > 6) {
        cc.view.setFrameSize(size[0] / 3, size[1] / 3);
    } else if (idx > 2) {
        cc.view.setFrameSize(size[0] / 2, size[1] / 2);
    } else {
        cc.view.setFrameSize(size[0], size[1]);
    }
}

var viewIndex = 0;

function testViewSize(view, designWidth, designHeight, policy, interval) {
    setViewSize(viewIndex++);
    cc.view.setDesignResolutionSize(designWidth, designHeight, policy);
    var reader = cce.NodeReader.create();
    var scene = reader.readNode(view);
    cc.director.runScene(scene);

    var size = view_size[viewIndex % view_size.length];

    cc.log("test view size " + size[0] + " " + size[1] + " " + (size[0] / size[1]) + " " + interval);

    scene.scheduleOnce(function (de) {
        testViewSize(view, designWidth, designHeight, policy, interval);
    }, interval);
}

cce.CCEReader.prototype.readNode = function (file, autoplay) {
    var node = this.read(file);
    if (node) {
        node.controllers = {};
        var names = this.getComponentNames();
        var animationManager = this.getAnimationManager();
        node.animationManager = animationManager;
        for (i = 0; i < names.length; i++) {
            var nodes = this.getComponentNodes(names[i]);
            for (var j = 0; j < nodes.length; j++) {
                eval("controller = new " + names[i] + "();");
                if (controller) {
                    controller.reader = this;
                    controller.animationManager = animationManager;
                    controller.setName(names[i]);
                    node.controllers[names[i]] = controller;
                    controller.init();
                    if (controller.nodes) {
                        var keys = Object.keys(controller.nodes);
                        for (var k = 0; k < keys.length; k++) {
                            //cc.log("bind node " + keys[k]);
                            controller.nodes[keys[k]] = this.getRef(keys[k]);
                        }
                    }
                    if (controller.callbacks) {
                        var callbacks = Object.keys(controller.callbacks);
                        for (var k = 0; k < callbacks.length; k++) {
                            var name = callbacks[k];
                            var fun = controller.callbacks[callbacks[k]];
                            //cc.log("bind callback " + callbacks[k] + " " + fun);
                            //var callfunc = new cc.CallFunc(fun, controller);
                            //callfunc.retain();
                            //controller.animationManager.addCallFun(name, callfunc);
                            //fun.bind(controller);
                            var nFun = function (param1, param2) {
                                cc.log(param1 + param2 + this);
                                this.controller.callbacks[param2].call(this.controller, param1, param2);
                            }
                            animationManager.controller = controller;
                            controller.animationManager.addCallback(name, nFun);
                        }
                    }
                    if (controller.actions) {
                        var keys = Object.keys(controller.actions);
                        for (var k = 0; k < keys.length; k++) {
                            var actionOwner = this.getRef(keys[k]);
                            var actionFun = controller.actions[keys[k]];
                            if (actionOwner && actionFun) {
                                if (actionOwner.addTouchEventListener) {
                                    actionOwner.addTouchEventListener(actionFun, controller);
                                }
                            }
                        }
                    }
                    if (controller.touches) {
                        var keys = Object.keys(controller.touches);
                        for (var k = 0; k < keys.length; k++) {
                            var actionOwner = this.getRef(keys[k]);
                            var actionFun = controller.touches[keys[k]];
                            if (actionOwner && actionFun) {
                                if (actionOwner.addTouchEventListener) {
                                    actionOwner.addTouchEventListener(actionFun, controller);
                                }
                            }
                        }
                    }
                    if (controller.clicks) {
                        var keys = Object.keys(controller.clicks);
                        var funMap = {};
                        for (var k = 0; k < keys.length; k++) {
                            var actionOwner = this.getRef(keys[k]);
                            var actionFun = controller.clicks[keys[k]];

                            if (actionOwner && actionFun) {
                                var nFun = function (param1, param2) {
                                    this.controller.clicks[this.name].call(controller, param1, param2);
                                };
                                actionOwner.controller = controller;
                                if (actionOwner.addClickEventListener) {
                                    actionOwner.addClickEventListener(nFun);
                                } else if (actionOwner.initWithCallback) {
                                    actionOwner.initWithCallback(nFun);
                                }
                            }
                        }
                    }
                    cc.log("bind component " + names[i] + " " + nodes[i]);
                    nodes[i].addComponent(controller);
                }
            }
        }

        if ("undefined" == typeof autoplay || autoplay) {
            animationManager.playAuto();
        }
    }
    return node;
};

cce.NodeReader = cce.CCEReader;

cce.functionFactory = cce.FunctionFactory.getInstance();


cce.CCEReader.getTransitionScene = function (layout, transition, time) {
    var reader = cce.NodeReader.create();
    var scene = reader.readNode(layout);
    if (scene) {
        var fun = sceneTransitions[transition];
        if (fun) {
            scene = fun(time, scene);
        }
    }
    return scene;
}

cce.CCEReader.getScene = function (name) {
    var args = name.split(' ');
    var reader = cce.NodeReader.create();
    var scene;
    if (args.length > 0) {
        scene = reader.readNode(args[0]);
    }
    if (args.length > 1) {
        var time = TRANSITION_DURATION;
        if (args.length > 2) {
            time = parseFloat(args[2]);
        }
        var fun = sceneTransitions[args[1]];
        if (fun) {
            scene = fun(time, scene);
        }
    }
    return scene;
}

cce.functionFactory.registerCallbackFunction("runScene", function (name, arg) {
    cc.log("run " + name + " " + arg);
    var scene = cce.CCEReader.getScene(arg);
    if (scene != null) {
        cc.director.runScene(scene);
    }

});

cce.functionFactory.registerCallbackFunction("replaceScene", function (name, arg) {
    cc.log("run " + name + " " + arg);

    var scene = cce.CCEReader.getScene(arg);
    if (scene != null) {
        cc.director.replaceScene(scene);
    }
});

cce.functionFactory.registerCallbackFunction("pushScene", function (name, arg) {
    cc.log("run " + name + " " + arg);

    var scene = cce.CCEReader.getScene(arg);
    if (scene != null) {
        cc.director.pushScene(scene);
    }
});


cce.Controller = cc.Component.extend({
    ctor: function () {
        this._super();
    },
    init: function () {
        return true;
    }
});